#include <string.h>
#include <errno.h>
#include <string>
#include <iostream>
#include "exit.h"
#include <stdio.h>

static int runProgram(const char * program);

int main(int argc, char *argv[])
{
    int exitCode = runProgram("./_gl32 0xdead 0xbeef");
    if (exitCode == -1)
    {
        cerr << "Failed to run _gl32: " << strerror(errno) << endl;
    }
    else
    {
        while ((exitCode == EXIT_RUN_BATCH_FILE) ||
               (exitCode == EXIT_RUN_DEBUGGED_BATCH_FILE))
        {
            (void) runProgram("/bin/sh ./runit.sh");
            exitCode = runProgram("./_gl32 0xdead 0xbeef");
            if (exitCode == -1)
            {
                cerr << "Failed to run _gl32: " << strerror(errno) << endl;
            }
        }
    }

    if (exitCode == EXIT_ERROR)
    {
        cerr << "An error occurred.  "
             << "See \"logs/glaunch.log\" for more information\n";
    }

    if (exitCode == EXIT_NO_LOG_DIRECTORY)
    {
        cerr << "Could not create \"logs\" directory\n";
    }

    return 0;
}

static int runProgram(const char * program)
{
    int rc = system(program);
    if (rc != -1)
    {
        rc >>= 8;
    }

    return rc;
}
