#include "view.h"

using namespace GameLauncher;

Background_Music_Listener::~Background_Music_Listener()
{
}

void
Null_Background_Music_Listener::skip_to_next_song(
    const Background_Music_Event * event)
{
}


void
Null_Background_Music_Listener::start_song_over(
    const Background_Music_Event * event)
{
}


/************************************************************************/


Background_Music_VC::Background_Music_VC(Engine * engine)
{
    p_skip_key = engine->get_keypress_factory()->create_keypress_watcher(0);
    p_skip_key->set_one_time();

    p_start_over_key =
        engine->get_keypress_factory()->create_keypress_watcher(0);
    p_start_over_key->set_one_time();

    p_null_listener = new Null_Background_Music_Listener();
    p_listener = p_null_listener;
}

Background_Music_VC::~Background_Music_VC()
{
    delete p_null_listener;
    delete p_skip_key;
}

bool
Background_Music_VC::update()
{
    if (p_skip_key->is_pressed())
    {
        Background_Music_Event  event;
        
        p_listener->skip_to_next_song(&event);
    }

    if (p_start_over_key->is_pressed())
    {
        Background_Music_Event  event;
        
        p_listener->start_song_over(&event);
    }

    return false;
}

void
Background_Music_VC::set_skip_key(int scancode)
{
    p_skip_key->set_scancode(scancode);
}

void
Background_Music_VC::set_start_over_key(int scancode)
{
    p_start_over_key->set_scancode(scancode);
}

void Background_Music_VC::set_listener(Background_Music_Listener * listener)
{
    if (listener == 0)
        p_listener = p_null_listener;
    else
        p_listener = listener;
}
