#ifndef _CDBGI_H_
#define _CDBGI_H_

#include "cdbg.h"

namespace GameLauncher
{
    using namespace GameEngine;

    class CD_Background_Impl : public CD_Background
    {
      public:

        CD_Background_Impl() throw(InitError);

        virtual ~CD_Background_Impl();

        virtual void    poll();
        virtual void    resume();
        virtual void    suspend();

        virtual int     current_frame() const;
        virtual int     total_frames() const;
        
        virtual void    seek(int seek_frame);
        virtual void    set_volume(int volume);
        
      private:

        Engine *        p_engine;
        bool            p_suspended;
        int             p_first_frame;
        int             p_last_frame;
        int             p_current_frame;
        int             p_total_frames;
        unsigned int    p_elapsed_seconds;
    };
};

#endif

/* Local Variables: */
/* mode: c++ */
/* End: */
